# Quick start

-Add lib:

npm install ng-bootstrap-routable-modal

-Import module:

import { NgBootstraproutableModalModule } from 'ng-bootstrap-routable-modal';

NgBootstraproutableModalModule.forRoot({
modalsConfigurations: [{ component: DemoModalComponent, name: 'demo' }],
}),

-Use the service for open the modal:

import { RoutableModalService } from 'ng-bootstrap-routable-modal';

constructor(public routableModalService: RoutableModalService) {}

this.routableModalService.show('demo', undefined, {
ciao: 111,
});

-Exemple of a Modal:

export class DemoModalComponent implements OnInit {
@Input() params: any;

public form!: FormGroup;

constructor(
public activeModal: NgbActiveModal,
private fb: FormBuilder,
private routableModalService: RoutableModalService
) {}

ngOnInit(): void {
this.form = this.fb.group({ ciao: null });
this.form.patchValue(this.params);
this.form.valueChanges.subscribe((f) =>
this.routableModalService.updateQueryParams(f)
);
}

passBack() {
this.activeModal.close(this.form.getRawValue());
}
}

-Subscribe of the close event needed for refresh automatic open modal:

this.routableModalService.openModal$
.pipe(filter((r) => r?.name === 'demo'))
.subscribe((r) => r?.ref?.closed.subscribe((r) => console.dir(r)));
